%global commit 280aac5a0ee09c45b17ec4be0681397f7c34c12e
%global shortcommit %(c=%{commit}; echo ${c:0:7})

#global gitdate 20210201
%global pkgname %{?gitdate:xserver}%{!?gitdate:xwayland}

%global default_font_path "catalogue:/etc/X11/fontpath.d,built-ins"

Summary:   Xwayland
Name:      x11-server-xwayland
Version:   22.1.9
%define subrel 6
Release:   %mkrel 1
Group:     System/X11

URL:       https://www.x.org/
%if 0%{?gitdate}
Source0:   https://gitlab.freedesktop.org/xorg/%{pkgname}/-/archive/%{commit}/%{pkgname}-%{shortcommit}.tar.gz
%else
Source0:   https://www.x.org/pub/individual/xserver/%{pkgname}-%{version}.tar.xz
%endif
Patch0:    CVE-2023-5367.patch
Patch1:    CVE-2023-5380.patch
Patch2:    CVE-2023-5574.patch
Patch3:    CVE-2023-6377.patch
Patch4:    CVE-2023-6478.patch
Patch5:    9e2ecb2af8302dedc49cb6a63ebe063c58a9e7e3.patch
Patch6:    ece23be888a93b741aa1209d1dbf64636109d6a5.patch
Patch7:    219c54b8a3337456ce5270ded6a67bcde53553d5.patch
Patch8:    df3c65706eb169d5938df0052059f3e0d5981b74.patch
Patch9:    4a5e9b1895627d40d26045bd0b7ef3dce503cbd1.patch
Patch10:   bc1fdbe46559dd947674375946bbef54dd0ce36b.patch
Patch11:   26769aa71fcbe0a8403b7fb13b7c9010cc07c3a8.patch
Patch12:   2ef0f1116c65d5cb06d7b6d83f8a1aea702c94f7.patch
Patch13:   e5e8586a12a3ec915673edffa10dc8fe5e15dac3.patch
Patch14:   96798fc1967491c80a4d0.patch
Patch15:   3e77295f888c67fc7645d.patch
Patch16:   bdca6c3d1f5057eeb3160.patch
Patch17:   337d8d48b618d4fc0168a7b978be4c3447650b04.patch
Patch18:   85b776571487f52e756f68a069c768757369bfe3.patch

# upstream stable 21.1

# upstream master

License:   MIT

Requires: x11-server-common
#Requires: libEGL
#Requires: libepoxy >= 1.5.5

# force new gcc
BuildRequires: gcc >= 12.0.1-0.20220227.2
BuildRequires: binutils >= 1:2.38-4

BuildRequires: git-core
BuildRequires: meson

BuildRequires: wayland-devel
BuildRequires: pkgconfig(wayland-client) >= 1.3.0
BuildRequires: pkgconfig(wayland-protocols)
BuildRequires: pkgconfig(wayland-eglstream-protocols)

BuildRequires: pkgconfig(epoxy) >= 1.5.5
BuildRequires: pkgconfig(fontenc)
BuildRequires: pkgconfig(libdrm) >= 2.4.0
BuildRequires: pkgconfig(libssl)
BuildRequires: pkgconfig(libtirpc)
BuildRequires: pkgconfig(pixman-1)
BuildRequires: pkgconfig(x11)
BuildRequires: pkgconfig(xau)
BuildRequires: pkgconfig(xdmcp)
BuildRequires: pkgconfig(xext)
BuildRequires: pkgconfig(xfixes)
BuildRequires: pkgconfig(xfont2)
BuildRequires: pkgconfig(xi)
BuildRequires: pkgconfig(xinerama)
BuildRequires: pkgconfig(xkbfile)
BuildRequires: pkgconfig(xmu)
BuildRequires: pkgconfig(xorg-macros) >= 1.17
BuildRequires: pkgconfig(xpm)
BuildRequires: pkgconfig(xrender)
BuildRequires: pkgconfig(xres)
BuildRequires: pkgconfig(xshmfence) >= 1.1
BuildRequires: pkgconfig(xtrans) >= 1.3.2
BuildRequires: pkgconfig(xtst)
BuildRequires: pkgconfig(xv)
BuildRequires: x11-proto-devel >= 7.7-10

BuildRequires: pkgconfig(dri)
BuildRequires: pkgconfig(gl)
BuildRequires: pkgconfig(egl)
BuildRequires: pkgconfig(gbm)
BuildRequires: pkgconfig(libxcvt) 

BuildRequires: audit-libs-devel
#BuildRequires: libselinux-devel >= 2.0.86-1

# libunwind is Exclusive for the following arches
%ifarch aarch64 %{arm} hppa ia64 mips ppc ppc64 %{ix86} x86_64
%if !0%{?rhel}
BuildRequires: libunwind-devel
%endif
%endif

BuildRequires: pkgconfig(xcb-aux)
BuildRequires: pkgconfig(xcb-image)
BuildRequires: pkgconfig(xcb-icccm)
BuildRequires: pkgconfig(xcb-keysyms)
BuildRequires: pkgconfig(xcb-renderutil)

%description
Xwayland is an X server for running X clients under Wayland.

%package devel
Summary: Development package
Requires: pkgconfig

%description devel
The development package provides the developmental files which are
necessary for developing Wayland compositors using Xwayland.

%prep
%autosetup -S git_am -n %{pkgname}-%{?gitdate:%{commit}}%{!?gitdate:%{version}}

%build
%meson \
        -Dxwayland_eglstream=true \
        -Ddefault_font_path=%{default_font_path} \
        -Dbuilder_string="Build ID: %{name} %{version}-%{release}" \
        -Dxkb_output_dir=%{_localstatedir}/lib/xkb \
        -Dxcsecurity=true \
        -Dglamor=true \
        -Ddri3=true

%meson_build

%install
%meson_install

# Remove unwanted files/dirs
rm $RPM_BUILD_ROOT%{_mandir}/man1/Xserver.1*
rm -Rf $RPM_BUILD_ROOT%{_libdir}/xorg
rm -Rf $RPM_BUILD_ROOT%{_includedir}/xorg
rm -Rf $RPM_BUILD_ROOT%{_datadir}/aclocal
rm -Rf $RPM_BUILD_ROOT%{_localstatedir}/lib/xkb

%files
%{_bindir}/Xwayland
%{_mandir}/man1/Xwayland.1*

%files devel
%{_libdir}/pkgconfig/xwayland.pc



%changelog
* Mon Nov 04 2024 ns80 <ns80> 22.1.9-1.6.mga9
+ Revision: 2112368
- add upstream patch for CVE-2024-9632 (mga#33710)
- add an upstream patch for possible double-free in ProcRenderAddGlyphs() (mga#33101)
- add upstream patches for CVE-2024-3108[013] (mga#33058)
- add uptream patches for CVE-2023-6816, CVE-2024-0229, CVE-2024-2188[56] and CVE-2024-040[89] (mga#32747)
- add patches from Ubuntu for CVE-2023-6377 and CVE-2023-6478 (mga#32625)
- add upstream patches for CVE-2023-5367, CVE-2023-5380 and CVE-2023-5574 (mga#32453)

* Tue Apr 04 2023 ns80 <ns80> 22.1.9-1.mga9
+ Revision: 1951399
- new version 22.1.9 for CVE-2023-1393 (mga#31732)

* Wed Feb 08 2023 tmb <tmb> 22.1.8-1.mga9
+ Revision: 1939476
- update to 22.1.8

* Fri Dec 30 2022 tmb <tmb> 22.1.7-1.mga9
+ Revision: 1928265
- update to 22.1.7

* Wed Dec 14 2022 tv <tv> 22.1.6-1.mga9
+ Revision: 1922325
- xwayland 22.1.6
  Fixes CVE-2022-46340, CVE-2022-46341, CVE-2022-46342, CVE-2022-46343,
  CVE-2022-46344, CVE-2022-4283

* Tue Nov 08 2022 tmb <tmb> 22.1.5-1.mga9
+ Revision: 1904760
- update to 22.1.5

* Tue Jul 12 2022 tmb <tmb> 22.1.3-1.mga9
+ Revision: 1868567
- update to 22.1.3

* Fri May 27 2022 tmb <tmb> 22.1.2-1.mga9
+ Revision: 1860542
- update to 22.1.2

* Thu Mar 31 2022 tmb <tmb> 22.1.1-1.mga9
+ Revision: 1837057
- update to 22.1.1

* Thu Mar 31 2022 umeabot <umeabot> 22.1.0-7.mga9
+ Revision: 1835775
- Mageia 9 Mass Rebuild

* Thu Mar 03 2022 tmb <tmb> 22.1.0-6.mga9
+ Revision: 1788166
- rebuild with gcc 12

* Thu Feb 17 2022 tmb <tmb> 22.1.0-4.mga9
+ Revision: 1779452
- rebuild with glibc 2.35-3

* Wed Feb 16 2022 tv <tv> 22.1.0-2.mga9
+ Revision: 1778270
- xwayland 22.1.0

* Sat Feb 12 2022 tmb <tmb> 22.0.99.901-2.mga9
+ Revision: 1773194
- rebuild with glibc 2.35

* Sat Jan 22 2022 tv <tv> 22.0.99.901-1.mga9
+ Revision: 1769404
- XWayland 22.1 RC1

* Tue Dec 14 2021 tmb <tmb> 21.1.4-1.mga9
+ Revision: 1762071
- update to 21.1.4

* Mon Nov 08 2021 tmb <tmb> 21.1.3-1.mga9
+ Revision: 1754721
- update to 21.1.3

* Fri Nov 05 2021 tmb <tmb> 21.1.2.901-2.mga9
+ Revision: 1753981
- xwayland: Store EGLContext pointer in lastGLContext

* Mon Nov 01 2021 tv <tv> 21.1.2.901-1.mga9
+ Revision: 1753541
- xwayland 21.1.2.901 (aka 21.1.3 RC1)

* Sat Oct 02 2021 wally <wally> 21.1.2-2.mga9
+ Revision: 1747901
- rebuild for openssl 3.0.0

* Mon Jul 19 2021 tv <tv> 21.1.2-1.mga9
+ Revision: 1737076
- xwayland 21.1.2

* Tue Jul 06 2021 tv <tv> 21.1.1.901-1.mga9
+ Revision: 1734950
- xwayland 21.1.1.901

* Mon Jun 21 2021 tv <tv> 21.1.1-3.mga9
+ Revision: 1731608
- Fix a use-after-free in the previous changes for GLX

* Mon Jun 14 2021 tv <tv> 21.1.1-2.mga9
+ Revision: 1730681
- Backport fixes for GLX and EGLstream (rhbz#1948003)

* Tue Apr 13 2021 tmb <tmb> 21.1.1-1.mga9
+ Revision: 1715696
- update to 21.1.1 (CVE-2021-3472, mga#28774)

* Thu Mar 18 2021 tv <tv> 21.1.0-1.mga9
+ Revision: 1704379
- xwayland 21.1.0

* Tue Mar 16 2021 tv <tv> 21.0.99.902-1.mga9
+ Revision: 1703861
- imported package x11-server-xwayland


* Tue Mar 16 2021 Thierry Vignaud <tv@mageia.org> 21.0.99.902-1.mga9
- Initial import, split from x11-server
